### Enumeration

# Pango.AttrType

#### Declaration

    enum Pango.AttrType

#### Description [src]

The `PangoAttrType` distinguishes between different types of attributes.

Along with the predefined values, it is possible to allocate additional values for custom attributes using [type_func@attr_type_register]. The predefined values are given below. The type of structure used to store the attribute is listed in parentheses after the description.

#### Members

Name | Description
--- | ---
`PANGO_ATTR_INVALID` | does not happen
`PANGO_ATTR_LANGUAGE` | language (`PangoAttrLanguage`)
`PANGO_ATTR_FAMILY` | font family name list (`PangoAttrString`)
`PANGO_ATTR_STYLE` | font slant style (`PangoAttrInt`)
`PANGO_ATTR_WEIGHT` | font weight (`PangoAttrInt`)
`PANGO_ATTR_VARIANT` | font variant (normal or small caps) (`PangoAttrInt`)
`PANGO_ATTR_STRETCH` | font stretch (`PangoAttrInt`)
`PANGO_ATTR_SIZE` | font size in points scaled by `PANGO_SCALE` (`PangoAttrInt`)
`PANGO_ATTR_FONT_DESC` | font description (`PangoAttrFontDesc`)
`PANGO_ATTR_FOREGROUND` | foreground color (`PangoAttrColor`)
`PANGO_ATTR_BACKGROUND` | background color (`PangoAttrColor`)
`PANGO_ATTR_UNDERLINE` | whether the text has an underline (`PangoAttrInt`)
`PANGO_ATTR_STRIKETHROUGH` | whether the text is struck-through (`PangoAttrInt`)
`PANGO_ATTR_RISE` | baseline displacement (`PangoAttrInt`)
`PANGO_ATTR_SHAPE` | shape (`PangoAttrShape`)
`PANGO_ATTR_SCALE` | font size scale factor (`PangoAttrFloat`)
`PANGO_ATTR_FALLBACK` | whether fallback is enabled (`PangoAttrInt`)
`PANGO_ATTR_LETTER_SPACING` | letter spacing (`PangoAttrInt`)
`PANGO_ATTR_UNDERLINE_COLOR` | underline color (`PangoAttrColor`)
`PANGO_ATTR_STRIKETHROUGH_COLOR` | strikethrough color (`PangoAttrColor`)
`PANGO_ATTR_ABSOLUTE_SIZE` | font size in pixels scaled by `PANGO_SCALE` (`PangoAttrInt`)
`PANGO_ATTR_GRAVITY` | base text gravity (`PangoAttrInt`)
`PANGO_ATTR_GRAVITY_HINT` | gravity hint (`PangoAttrInt`)
`PANGO_ATTR_FONT_FEATURES` | OpenType font features (`PangoAttrString`). Since 1.38
`PANGO_ATTR_FOREGROUND_ALPHA` | foreground alpha (`PangoAttrInt`). Since 1.38
`PANGO_ATTR_BACKGROUND_ALPHA` | background alpha (`PangoAttrInt`). Since 1.38
`PANGO_ATTR_ALLOW_BREAKS` | whether breaks are allowed (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_SHOW` | how to render invisible characters (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_INSERT_HYPHENS` | whether to insert hyphens at intra-word line breaks (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_OVERLINE` | whether the text has an overline (`PangoAttrInt`). Since 1.46
`PANGO_ATTR_OVERLINE_COLOR` | overline color (`PangoAttrColor`). Since 1.46

#### Type functions

###### pango_attr_type_get_name

Fetches the attribute type name.

###### pango_attr_type_register

Allocate a new attribute type ID.